



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux下逻辑地址-线性地址-物理地址图解(转)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux下逻辑地址-线性地址-物理地址图解(转)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 12:54:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、逻辑地址转线性地址</strong>
<p>机器语言指令中出现的内存地址，都是逻辑地址，需要转换成线性地址，再经过MMU(CPU中的内存管理单元)转换成物理地址才能够被访问到。
<p>我们写个最简单的hello world程序，用gccs编译，再反编译后会看到以下指令：
<p>mov&nbsp;&nbsp;&nbsp; 0x80495b0, %eax
<p>这里的内存地址0x80495b0 就是一个逻辑地址，必须加上隐含的DS 数据段的基地址，才能构成线性地址。也就是说 0x80495b0 是当前任务的DS数据段内的偏移。
<p>在x86保护模式下，段的信息（段基线性地址、长度、权限等）即<strong>段描述符</strong>占8个字节，段信息无法直接存放在段寄存器中（段寄存器只有2字节）。Intel的设计是段描述符集中存放在GDT或LDT中，而<strong>段寄存器存放的是段描述符在</strong><strong>GDT</strong><strong>或LDT</strong><strong>内的索引值</strong>(index)。
<p><strong>Linux</strong><strong>中逻辑地址等于线性地址</strong>。为什么这么说呢？因为Linux所有的段（用户代码段、用户数据段、内核代码段、内核数据段）的线性地址都是从 0x00000000 开始，长度4G，这样 线性地址=逻辑地址+ 0x00000000，也就是说逻辑地址等于线性地址了。
<p>这样的情况下<strong>Linux</strong><strong>只用到了GDT</strong>，不论是用户任务还是内核任务，都没有用到LDT。GDT的第12和13项段描述符是 __KERNEL_CS 和__KERNEL_DS，第14和15项段描述符是 __USER_CS 和__USER_DS。内核任务使用__KERNEL_CS和__KERNEL_DS，所有的用户任务共用__USER_CS 和__USER_DS，也就是说不需要给每个任务再单独分配段描述符。内核段描述符和用户段描述符虽然起始线性地址和长度都一样，但DPL(描述符特权级)是不一样的。__KERNEL_CS 和__KERNEL_DS 的DPL值为0（最高特权），__USER_CS 和__USER_DS的DPL值为3。
<p>用gdb调试程序的时候，用info reg 显示当前寄存器的值：
<p>cs&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x73&nbsp;&nbsp;&nbsp;&nbsp; 115
<p>ss&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x7b&nbsp;&nbsp;&nbsp;&nbsp; 123
<p>ds&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x7b&nbsp;&nbsp;&nbsp;&nbsp; 123
<p>es&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x7b&nbsp;&nbsp;&nbsp;&nbsp; 123
<p>可以看到ds值为0x7b, 转换成二进制为 00000000 01111011，TI字段值为0,表示使用GDT，GDT索引值为 01111，即十进制15，对应的就是GDT内的__USER_DATA 用户数据段描述符。
<p>从上面可以看到，Linux在x86的分段机制上运行，却通过一个巧妙的方式绕开了分段。
<p>Linux主要以分页的方式实现内存管理。
<p><img referrerpolicy="no-referrer"src="http://1841.img.pp.sohu.com.cn/images/blog/2009/9/15/19/23/1246bcc90f7g214.jpg">
<p><strong>二、线性地址转物理地址</strong>
<p>前面说了Linux中逻辑地址等于线性地址，那么线性地址怎么对应到物理地址呢？这个大家都知道，那就是通过分页机制，具体的说，就是通过页表查找来对应物理地址。
<p>准确的说分页是CPU提供的一种机制，Linux只是根据这种机制的规则，利用它实现了内存管理。
<p>在保护模式下，控制寄存器CR0的最高位PG位控制着分页管理机制是否生效，如果PG=1，分页机制生效，需通过页表查找才能把线性地址转换物理地址。如果PG=0，则分页机制无效，线性地址就直接做为物理地址。
<p>分页的基本原理是把内存划分成大小固定的若干单元，每个单元称为一页（page），每页包含4k字节的地址空间（为简化分析，我们不考虑扩展分页的情况）。这样每一页的起始地址都是4k字节对齐的。为了能转换成物理地址，我们需要给CPU提供<strong>当前任务的</strong>线性地址转物理地址的查找表，即页表(page table)。注意，<strong>为了实现每个任务的平坦的虚拟内存，每个任务都有自己的页目录表和页表</strong>。
<p>为了节约页表占用的内存空间，x86将线性地址通过页目录表和页表两级查找转换成物理地址。
<p>32位的线性地址被分成3个部分：
<p>最高10位 Directory 页目录表偏移量，中间10位 Table是页表偏移量，最低12位Offset是物理页内的字节偏移量。
<p>页目录表的大小为4k（刚好是一个页的大小），包含1024项，每个项4字节（32位），项目里存储的内容就是<strong>页表的物理地址</strong>。如果页目录表中的页表尚未分配，则物理地址填0。
<p>页表的大小也是4k，同样包含1024项，每个项4字节，内容为最终物理页的物理内存起始地址。
<p><strong>每个活动的任务，必须要先分配给它一个页目录表，并把页目录表的物理地址存入cr3</strong><strong>寄存器。页表可以提前分配好，也可以在用到的时候再分配</strong>。
<p>还是以 mov 0x80495b0, %eax 中的地址为例分析一下线性地址转物理地址的过程。
<p>前面说到Linux中逻辑地址等于线性地址，那么我们要转换的线性地址就是0x80495b0。转换的过程是由CPU自动完成的，Linux所要做的就是准备好转换所需的页目录表和页表（假设已经准备好，给页目录表和页表分配物理内存的过程很复杂，后面再分析）。
<p>内核先将当前任务的页目录表的物理地址填入cr3寄存器。
<p>线性地址 0x80495b0 转换成二进制后是 0000 1000 0000 0100 1001 0101 1011 0000，最高10位0000 1000 00的十进制是32，CPU查看页目录表第32项，里面存放的是页表的物理地址。线性地址中间10位00 0100 1001 的十进制是73，页表的第73项存储的是最终物理页的物理起始地址。物理页基地址加上线性地址中最低12位的偏移量，CPU就找到了线性地址最终对应的物理内存单元。
<p>我们知道Linux中用户进程线性地址能寻址的范围是0 － 3G，那么是不是需要提前先把这3G虚拟内存的页表都建立好呢？一般情况下，物理内存是远远小于3G的，加上同时有很多进程都在运行，根本无法给每个进程提前建立3G的线性地址页表。Linux利用CPU的一个机制解决了这个问题。进程创建后我们可以给页目录表的表项值都填0，CPU在查找页表时，如果表项的内容为0,则会引发一个缺页异常，进程暂停执行，Linux内核这时候可以通过一系列复杂的算法给分配一个物理页，并把物理页的地址填入表项中，进程再恢复执行。当然进程在这个过程中是被蒙蔽的，它自己的感觉还是正常访问到了物理内存。
<p><img referrerpolicy="no-referrer"src="http://1821.img.pp.sohu.com.cn/images/blog/2009/9/15/20/0/1246bd352ddg214.jpg"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j0mgeq.html">查看Oracle执行计划</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8egoxj9.html">fis3安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvxvwj8.html">如何在windows中编写R程序包&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm1yw49.html">山东理工大学第七届ACM校赛-完美素数                                                       分类：            比赛             2015-06-26 10&colon;36    15人阅读    评论&lpar;0&rpar;    收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1o2nx9.html">Java--&amp;gt&semi;多线程断点续传</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o3wjj9.html">Java之NIO传输数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ydgejq.html">LeetCode&colon; Combination Sum I &amp;amp&semi;&amp;amp&semi; II &amp;amp&semi;&amp;amp&semi; III</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wvdwvq.html">nutch 采集效率--设置采集间隔</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdp76y8.html">Count The Pairs</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x1rdg9.html">JS实现一键复制功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn00r2q.html">BZOJ 2115&colon; &lbrack;Wc2011&rsqb; Xor</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn1k1oq.html">java基础知识再学习--集合框架-对象的强、软、弱和虚引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdvw2m8.html">Java compiler level does not match the version of the installed Java project facet&period;解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mploxq.html">JavaScrtip之JS最佳实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjem5l8.html">第一节 JDK是什么&quest;JRE是什么&quest;JDK和JRE的区别&quest;以及jdk安装和测试。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj3ye38.html">centos7安装kubeadm</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p6nov8.html">手动创建Oracle实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jk2j5q.html">下载网络文件HttpURLConnection&period;getContentLength&lpar;&rpar;大小为 0</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwglmz9.html">SQL-触发器-011</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw2e0k8.html">ActiveMQ&lowbar;7JMX</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/902mmmjq.html">spring-boot 速成&lpar;12&rpar; - 如何注入多个redis StringRedisTemplate</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkooj38.html">PHP之PDO&lowbar;MYSQL扩展安装步骤&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95300y68.html">Serilog简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjpwd7q.html">AES Test vectors</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rng4n7q.html">关于GPL协议的理解（开源与商用、免费与收费的理解）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rng4edq.html">AutoMapper在MVC中的运用01-配置、使用、单元测试、举例</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpe3279.html">AdjustWindowRect 与 SetWindowPos</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vkpn0q.html">将 tomcat 安装成 windows 服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve1rvo9.html">springMVC helloworld入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjpzpxq.html">TDD：simply mocking a class is not necessarily the best practice</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
